import Flutter
import UIKit
import Lemnisk


public class FlutterWrapperPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_wrapper", binaryMessenger: registrar.messenger())
    let instance = FlutterWrapperPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
    case "getPlatformVersion":
      result("iOS " + UIDevice.current.systemVersion)
      break
    case "track":
      if let arguments = call.arguments as? [String: Any] {
          Lemnisk.shared.track(arguments["eventName"] as? String, properties:arguments["properties"] as? [String : Any], otherIds:arguments["otherIds"] as? [String : Any])
      }
      break
    case "screen":
      if let arguments = call.arguments as? [String: Any] {
        Lemnisk.shared.screen(arguments["name"] as? String, properties:arguments["properties"] as? [String : Any], otherIds:arguments["otherIds"] as? [String : Any])
      }
      break
    case "identify":
      if let arguments = call.arguments as? [String: Any] {
        Lemnisk.shared.identify(arguments["userId"] as? String, traits:arguments["properties"] as? [String : Any], otherIds:arguments["otherIds"] as? [String : Any])
      }
      break
    case "registerForPush":
        Lemnisk.shared.registerForPushNotifications()
      break
    case "getCookieId":
        result(Lemnisk.shared.showTrackingDialog())
        break
    default:
      result(FlutterMethodNotImplemented)
    }
  }

}
