import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'flutter_wrapper_method_channel.dart';

abstract class FlutterWrapperPlatform extends PlatformInterface {
  /// Constructs a FlutterWrapperPlatform.
  FlutterWrapperPlatform() : super(token: _token);

  static final Object _token = Object();

  static FlutterWrapperPlatform _instance = LemniskFlutter();

  /// The default instance of [FlutterWrapperPlatform] to use.
  ///
  /// Defaults to [MethodChannelFlutterWrapper].
  static FlutterWrapperPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [FlutterWrapperPlatform] when
  /// they register themselves.
  static set instance(FlutterWrapperPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
