import 'package:flutter_test/flutter_test.dart';
import 'package:lemnisk_flutter/flutter_wrapper.dart';
import 'package:lemnisk_flutter/flutter_wrapper_platform_interface.dart';
import 'package:lemnisk_flutter/flutter_wrapper_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockFlutterWrapperPlatform
    with MockPlatformInterfaceMixin
    implements FlutterWrapperPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final FlutterWrapperPlatform initialPlatform = FlutterWrapperPlatform.instance;

  test('$LemniskFlutter is the default instance', () {
    expect(initialPlatform, isInstanceOf<LemniskFlutter>());
  });

  test('getPlatformVersion', () async {
    FlutterWrapper flutterWrapperPlugin = FlutterWrapper();
    MockFlutterWrapperPlatform fakePlatform = MockFlutterWrapperPlatform();
    FlutterWrapperPlatform.instance = fakePlatform;

    expect(await flutterWrapperPlugin.getPlatformVersion(), '42');
  });
}
